package java.awt.image;

import java.util.Hashtable;

public class ImageFilter implements ImageConsumer, Cloneable
{
    protected ImageConsumer consumer;
    
    public ImageFilter() {
    }
    
    public ImageFilter getFilterInstance(ImageConsumer consumer) {
        ImageFilter imageFilter = (ImageFilter)this.clone();
        imageFilter.consumer = consumer;
        return imageFilter;
    }
    
    @Override
    public void setDimensions(int n, int n2) {
        this.consumer.setDimensions(n, n2);
    }
    
    @Override
    public void setProperties(Hashtable<?, ?> hashtable) {
        Hashtable<String, String> properties = (Hashtable)hashtable.clone();
        Object value = properties.get("filters");
        if (value == null) {
            properties.put("filters", this.toString());
        }
        else if ((value instanceof String)) {
            properties.put("filters", (String)value + this.toString());
        }
        this.consumer.setProperties(properties);
    }
    
    @Override
    public void setColorModel(ColorModel colorModel) {
        this.consumer.setColorModel(colorModel);
    }
    
    @Override
    public void setHints(int hints) {
        this.consumer.setHints(hints);
    }
    
    @Override
    public void setPixels(int n, int n2, int n3, int n4, ColorModel colorModel, byte[] array, int n5, int n6) {
        this.consumer.setPixels(n, n2, n3, n4, colorModel, array, n5, n6);
    }
    
    @Override
    public void setPixels(int n, int n2, int n3, int n4, ColorModel colorModel, int[] array, int n5, int n6) {
        this.consumer.setPixels(n, n2, n3, n4, colorModel, array, n5, n6);
    }
    
    @Override
    public void imageComplete(int n) {
        this.consumer.imageComplete(n);
    }
    
    public void resendTopDownLeftRight(ImageProducer imageProducer) {
        imageProducer.requestTopDownLeftRightResend(this);
    }
    
    public Object clone() {
        try {
            return super.clone();
        }
        catch (CloneNotSupportedException cause) {
            throw new InternalError(cause);
        }
    }
}
